@webUI
Feature: DeleteFirewallGroups

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "firewallGrp"
    And these users have been created with skeleton files:
      | username |
      | Alice    |

  Scenario: create, save and delete a single group with one rule
    Given the user places a rule with the filter "File mimetype upload", the operator "is" and the value "text/plain" in the group named "firewallGrp"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the firewall rule group named "firewallGrp"
    And the user saves the firewall rules
    Then it should be possible to upload a file with the mime-type "text/plain" using "any" dav path
    And it should be possible to upload a file with the mime-type "image/jpeg" using "any" dav path

  Scenario: create two groups with one rule in each of them, delete the first group
    Given the user places a rule with the filter "Request Time", the operator "between" and the value "now -1 hour,now +1 hour" in the group named "firewallGrp"
    And the user has created an empty firewall rule group named "firewallGrp2"
    And the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp2"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the firewall rule group named "firewallGrp"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    But it should not be possible for user "Alice" to download the file "testimage.png" using "any" dav path

  Scenario: create two groups with one rule in each of them, delete the last group
    Given the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp"
    And the user has created an empty firewall rule group named "firewallGrp2"
    And the user has placed a rule with the filter "Request Time", the operator "between" and the value "now -1 hour,now +1 hour" in the group named "firewallGrp2"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the firewall rule group named "firewallGrp2"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    But it should not be possible for user "Alice" to download the file "testimage.png" using "any" dav path

  Scenario: create three groups with one rule in each of them, delete the middle group
    Given the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp"
    And the user has created an empty firewall rule group named "firewallGrp2"
    And the user has placed a rule with the filter "Request Time", the operator "between" and the value "now -1 hour,now +1 hour" in the group named "firewallGrp2"
    And the user has created an empty firewall rule group named "firewallGrp3"
    And the user has placed a rule with the filter "File mimetype upload", the operator "is" and the value "text/plain" in the group named "firewallGrp3"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the firewall rule group named "firewallGrp2"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    But it should not be possible for user "Alice" to download the file "testimage.png" using "any" dav path
    And it should not be possible to upload a file with the mime-type "text/plain" using "any" dav path

  Scenario: create three groups with two rules in each of them, delete the middle group
    Given the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp"
    And the user has placed a regular expression rule with the filter "Request URL", the operator "is" and the value "testimage" in the group named "firewallGrp"
    And the user has created an empty firewall rule group named "firewallGrp2"
    And the user has placed a rule with the filter "Request Time", the operator "between" and the value "now -1 hour,now +1 hour" in the group named "firewallGrp2"
    And the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp2"
    And the user has created an empty firewall rule group named "firewallGrp3"
    And the user has placed a regular expression rule with the filter "Request URL", the operator "is" and the value "lorem" in the group named "firewallGrp3"
    And the user has placed a regular expression rule with the filter "User Agent", the operator "is" and the value "Windows" in the group named "firewallGrp3"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the firewall rule group named "firewallGrp2"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to download the file "testavatar.png" using "any" dav path
    And it should be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    But it should not be possible for user "Alice" to download the file "testimage.png" using "any" dav path
    And it should not be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
