@webUI @skipWhenTestingRemoteSystems
Feature: LimitFileAccessBasedOnRegexIpv4Subnet

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "ipsubnet-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |
    And user "Alice" has created a public link share of file "testimage.gif"

  Scenario: prohibit file access for an IPv4 subnet matching a regular expression
    When the user places a regular expression rule with the filter "Client IP Subnet (IPv4)", the operator "is" and the value "^127" in the group named "ipsubnet-limiter"
    And the user saves the firewall rules
    When the client accesses the server from a routable "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    And it should be possible to download the file "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    And it should not be possible to download the file "testimage.gif" through the last created public link

  Scenario: prohibit file access for an IPv4 subnet not matching a regular expression
    When the user places a regular expression rule with the filter "Client IP Subnet (IPv4)", the operator "is not" and the value "^127" in the group named "ipsubnet-limiter"
    And the user saves the firewall rules
    When the client accesses the server from a loopback "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    And it should be possible to download the file "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    And it should not be possible to download the file "testimage.gif" through the last created public link
