@webUI
Feature: LimitFileAccessBasedOnRegExRequestURL

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "regex-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |
    And user "Alice" has created folder "test_folder"
    And user "Alice" has copied file "lorem.txt" to "test_folder/lorem.txt"
    And user "Alice" has copied file "testimage.gif" to "test_folder/testimage.gif"
    And user "Alice" has copied file "textfile0.txt" to "test_folder/textfile0.txt"
    And user "Alice" has copied file "data.tar.gz" to "test_folder/data.tar.gz"
    And user "Alice" has created a public link share of file "test_folder"

  Scenario: prohibit file access for a Request URL matching a simple regular expression
    When the user places a regular expression rule with the filter "Request URL", the operator "is" and the value "lorem" in the group named "regex-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "testimage.gif" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.gif"
    But it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "lorem.txt"
    And it should not be possible to download the file "lorem.txt" through the last created public link
    But it should be possible to download the file "testimage.gif" through the last created public link

  Scenario: prohibit file access for a Request URL not matching a simple regular expression
    When the user places a regular expression rule with the filter "Request URL", the operator "is not" and the value "txt" in the group named "regex-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem-big.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "lorem.txt"
    And it should be possible to view the preview of "lorem.txt" through the last created public link
    And it should be possible to download the file "textfile0.txt" through the last created public link
    And it should not be possible for user "Alice" to download the file "testimage.gif" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.gif"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    And it should not be possible to download the file "testimage.gif" through the last created public link

  Scenario: prohibit file access for a Request URL matching a more complex regular expression
    When the user places a regular expression rule with the filter "Request URL", the operator "is not" and the value "\/[a-z]*\.[a-z]{3}$" in the group named "regex-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "data.zip" using "any" dav path
    But it should not be possible for user "Alice" to download the file "testapp2.zip" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage-wide.png"
    And it should not be possible to download the file "testimage.gif" through the last created public link
    And it should not be possible to download the file "textfile0.txt" through the last created public link
    And it should not be possible to download the file "data.tar.gz" through the last created public link
