@webUI
Feature: LimitFileAccessBasedOnRequestTime

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "requesttime-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |

  Scenario: prohibit file access for now
    When the user places a rule with the filter "Request Time", the operator "between" and the value "now,now +1 hour" in the group named "requesttime-limiter"
    And the user saves the firewall rules
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible to upload a file with the size of "2000" bytes using "any" dav path

  Scenario: prohibit file access for now and check the file previews
    When user "Alice" creates a public link share of file "testimage.jpg" using the sharing API
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now,now +1 hour" in the group named "requesttime-limiter"
    And the user saves the firewall rules
    Then it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.jpg" through the last created public link
    And it should not be possible to download the file "testimage.jpg" through the last created public link

  Scenario: prohibit file access for a time that is not now
    When the user places a rule with the filter "Request Time", the operator "between" and the value "now -2 hour,now -1 hour" in the group named "requesttime-limiter"
    And the user saves the firewall rules
    And user "Alice" creates a public link share of file "testimage.jpg" using the sharing API
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible to download the file "testimage.jpg" through the last created public link
