@webUI
Feature: LimitFileAccessBasedOnRequestType

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "requesttype-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |

  @the-public-link-is-only-to-avoid-issue-304
  Scenario: prohibit file access by WebDAV
    When the user places a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "requesttype-limiter"
    And the user saves the firewall rules
    And user "Alice" creates a public link share of file "testimage.jpg" using the sharing API
    Then it should not be possible to upload a file with the size of "20000" bytes using "any" dav path and any chunking
    And it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path

  Scenario: allow only WebDAV file access
    When the user places a rule with the filter "Request Type", the operator "is not" and the value "WebDAV" in the group named "requesttype-limiter"
    And the user saves the firewall rules
    And user "Alice" creates a public link share of file "testimage.jpg" using the sharing API
    Then it should be possible for user "Alice" to download the file "testimage.jpg" using "any" dav path
    But it should not be possible to download the file "testimage.jpg" through the last created public link
    And it should not be possible to view the preview of "testimage.jpg" through the last created public link
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg" using the old preview url
    But it should be possible for user "Alice" to view the preview of "testimage.jpg" using the new preview url

  Scenario: prohibit file access by Public Share Link
    When the user places a rule with the filter "Request Type", the operator "is" and the value "Public Share Link" in the group named "requesttype-limiter"
    And the user saves the firewall rules
    And user "Alice" creates a public link share of file "testimage.jpg" using the sharing API
    Then it should not be possible to download the file "testimage.jpg" through the last created public link
    And it should not be possible to view the preview of "testimage.jpg" through the last created public link
    But it should be possible for user "Alice" to download the file "testimage.jpg" using "any" dav path

  @issue-280
  Scenario: prohibit folder download by Public Share Link
    When the user places a rule with the filter "Request Type", the operator "is" and the value "Public Share Link" in the group named "requesttype-limiter"
    And the user saves the firewall rules
    And user "Alice" creates a public link share of folder "simple-folder" using the sharing API
    And the public downloads folder "simple-folder" through the last created public link
    # in issue-280 the request is for a zip file of the folder.
    # the response is a block of HTML with the "forbidden by a file firewall rule"
    # message embedded in it, but the HTTP status is 200
    # When the issue is fixed, the following lines should be deleted and something
    # similar to the commented-out line put in the scenario steps.
    Then the HTTP status code should be "200"
    But the response should indicate that access has been forbidden by a file firewall rule
    #Then it should not be possible to download the folder "simple-folder" through the last created public link
    And it should not be possible to download the file "lorem.txt" through the last created public link
