@webUI
Feature: LimitFileAccessBasedOnTags

  Background:
    Given using new dav path
    And the administrator has logged in using the webUI
    And user "%admin%" has created a "normal" tag with name "MyTagName"
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "tags-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |
    And user "Alice" has created folder "test_folder"
    And user "Alice" has copied file "lorem.txt" to "test_folder/lorem.txt"
    And user "Alice" has copied file "testimage.jpg" to "test_folder/testimage.jpg"
    And user "Alice" has copied file "textfile0.txt" to "test_folder/textfile0.txt"
    And user "Alice" has created a public link share of file "test_folder"

  Scenario: prohibit file access for files tagged with a specific tag
    When the user places a rule with the filter "System file tag", the operator "is" and the value "MyTagName" in the group named "tags-limiter"
    And the user saves the firewall rules
    And the user "Alice" tags the file "testimage.jpg" with these tags
      | MyTagName |
    And the user "Alice" tags the file "test_folder/testimage.jpg" with these tags
      | MyTagName |
    Then it should not be possible for user "Alice" to download the file "testimage.jpg" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.jpg" through the last created public link
    And it should not be possible to download the file "testimage.jpg" through the last created public link
    And it should not be possible to download the file "testimage.jpg" through the last created public link
    But it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible to download the file "lorem.txt" through the last created public link

  Scenario: prohibit access to files in a folder tagged with a specific tag
    When the user places a rule with the filter "System file tag", the operator "is" and the value "MyTagName" in the group named "tags-limiter"
    And the user saves the firewall rules
    And the user "Alice" tags the folder "simple-folder" with these tags
      | MyTagName |
    And user "Alice" creates a public link share of file "simple-folder/testimage.jpg" using the sharing API
    Then it should not be possible for user "Alice" to download the file "simple-folder/testimage.jpg" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "simple-folder/testimage.jpg"
    And it should not be possible to view the preview of "simple-folder/testimage.jpg" through the last created public link
    And it should not be possible to download the file "simple-folder/testimage.jpg" through the last created public link
    But it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    When user "Alice" creates a public link share of file "testimage.jpg" using the sharing API
    Then it should be possible to view the preview of "testimage.jpg" through the last created public link
    And it should be possible to download the file "testimage.jpg" through the last created public link

  Scenario: prohibit file access for all files that are not tagged with a specific tag
    When the user "Alice" tags the file "data.zip" with these tags
      | MyTagName |
    And the user "Alice" tags the file "test_folder/textfile0.txt" with these tags
      | MyTagName |
    And the user places a rule with the filter "System file tag", the operator "is not" and the value "MyTagName" in the group named "tags-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "data.zip" using "any" dav path
    But it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible to view the preview of "testimage.jpg" through the last created public link
    And it should not be possible to download the file "testimage.jpg" through the last created public link
    And it should be possible to download the file "textfile0.txt" through the last created public link
