@webUI
Feature: LimitFileAccessForNewUser

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "requesturl-limiter"
    And these users have been created with skeleton files but not initialized:
      | username |
      | Alice    |

  Scenario: prohibit file access based on specific Request URL and then request an allowed file first
    When the user places a rule with the filter "Request URL", the operator "is" and the value "%base_url%/remote.php/dav/files/Alice/lorem.txt" in the group named "requesturl-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "data.zip" using "v2" dav path
    But it should not be possible for user "Alice" to download the file "lorem.txt" using "v2" dav path

  @issue-304
  Scenario: prohibit file access based on specific Request URL and then request the prohibited file first
    When the user places a rule with the filter "Request URL", the operator "is" and the value "%base_url%/remote.php/dav/files/Alice/lorem.txt" in the group named "requesturl-limiter"
    And the user saves the firewall rules
    # The issue is that if you initially try to access the prohibited file, then building the user skeleton goes wrong,
    # and after that the user account is in trouble.
    # When fixing issue-304, remove the following 3 lines and uncomment the 2 lines below them.
    And using new dav path
    And user "Alice" downloads file "lorem.txt" using the WebDAV API
    Then the HTTP status code should be "503"
    #Then it should not be possible for user "Alice" to download the file "lorem.txt" using "v2" dav path
    #But it should be possible for user "Alice" to download the file "data.zip" using "v2" dav path
